% Unconstrained input - Ellipsoidal COntractive set P0
% System Model
global A B H h Hu hu nx nu gamma Ku
sys=0;
if sys==1
   A = [0.3 -0.2;0.1 0.1];
   B = [0.2 0.4;0.4 0.5];
elseif sys==0
A=[1 0.2;0 1];
B=[0.22;0.2];
end

%%
% Number of States
nx=size(A,2);
% Number of Inputs
nu=size(B,2);
% State Constraints
Hx=[eye(nx);-eye(nx)];
hx=5*ones(2*nx,1);
X=Polyhedron(Hx,hx);
% Number of State Constraints
nbox=size(Hx,1);
Hxp=zeros(nbox,nx);
for i=1:nbox
Hxp(i,:)=Hx(i,:)/hx(i);
end
% Input Constraints
Hu=[eye(nu);-eye(nu)];
hu=3*ones(2*nu,1);
U=Polyhedron(Hu,hu);
Hup=zeros(nbox,nu);
nubox=size(Hu,1);
for i=1:nubox
Hup(i,:)=Hu(i,:)/hu(i);
end

% State Penalty
Q = eye(nx);
% Input Penalty
R = eye(nu);

% Gain matrix K for unconstrained controller
[K,S,e] = dlqr(A,B,Q,R);
K=-K; % since dlqr finds K in u=-Kx and our formulations have u=kx;

%% Optimization
P = sdpvar(nx,nx);
Y=K*P;
Scont=[gamma*P P*A'+Y'*B';A*P+B*Y P];

%State Constraints
Pr = inv(P1);
CState = Pr - P;

%Sinput = [uimax^2 Yi;Yi' P] - Input Constraints
for i=1:nu
Sinput{i} = [hu(i)^2 Y(i,:);(Y(i,:))' P];
end

% Combining all constraints
constr=Scont>=0;
for i=1:nu
    constr=[constr, Sinput{i}>=0];
end
% for i=1:nbox
%     constr=[constr, CState>0];
% end
    constr=[constr, CState>=0];

%solvesdp(constr, -trace(P)); %logdet()
solvesdp(constr, -logdet(P)); %logdet()

P = value(P);
Y = value(Y);
K = Y*P^-1;

P0=inv(P);

%%  Plots
E0=ellipsoid(P);
v0=volume(E0);
hold on
ellipplot_OK(P,1,'g');